#ifndef NAGIOSSERVICELIST_H
#define NAGIOSSERVICELIST_H

#include <gtkmm/treeview.h>
#include <gtkmm/liststore.h>
#include <openwbem/OW_CIMOMHandleIFC.hpp>
#include <openwbem/OW_CIMInstance.hpp>
#include <time.h>
#include <openwbem/OW_CIMDateTime.hpp>
#include <openwbem/OW_DateTime.hpp>

class NagiosServiceList : public Gtk::TreeView
{
private:
	Glib::RefPtr<Gtk::ListStore> m_store;

public:
	NagiosServiceList(bool show_host_column = true);
	void show_hostgroup(OpenWBEM::CIMObjectPath hostgroup_cop);
	void show_host(OpenWBEM::CIMObjectPath host_cop);

private:
	class ModelColumns : public Gtk::TreeModel::ColumnRecord
	{
	public:
		ModelColumns()
		{
			add(host);
			add(service);
			add(status);
			add(last_check);
			add(duration);
			add(attempt);
			add(information);
			add(status_color);
			add(instobj);
		}
		Gtk::TreeModelColumn<Glib::ustring> host;
		Gtk::TreeModelColumn<Glib::ustring> service;
		Gtk::TreeModelColumn<Glib::ustring> status;
		Gtk::TreeModelColumn<Glib::ustring> last_check;
		Gtk::TreeModelColumn<Glib::ustring> duration;
		Gtk::TreeModelColumn<Glib::ustring> attempt;
		Gtk::TreeModelColumn<Glib::ustring> information;
		Gtk::TreeModelColumn<Glib::ustring> status_color;
		Gtk::TreeModelColumn<OpenWBEM::CIMInstance> instobj;
	};
	
	ModelColumns Columns;

protected:
	static time_t convertTime(OpenWBEM::CIMDateTime x)
		{
			OpenWBEM::DateTime date = x.toDateTime();
			return date.get();
		}
	static Glib::ustring duration2string(time_t seconds);
	virtual void on_instance_activated(OpenWBEM::CIMInstance inst);
	virtual void on_row_activated(const Gtk::TreeModel::Path &path,
			Gtk::TreeViewColumn *column);
	void add_service(OpenWBEM::CIMInstance &inst);
};

#endif /* NAGIOSSERVICELIST_H */
