#ifndef NAGIOSWINDOW_H
#define NAGIOSWINDOW_H

#include "InstanceList.h"
#include <gtkmm/window.h>
#include <gtkmm/box.h>
#include <gtkmm/menubar.h>
#include <gtkmm/menu.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/paned.h>
#include <gtkmm/treeview.h>
#include <openwbem/OW_CIMObjectPath.hpp>
#include "NagiosHostList.h"

class NagiosWindow : public Gtk::Window
{
private:
	// WIDGETS
	Gtk::VBox vbox;
	Gtk::MenuBar menu_bar;
	Gtk::Menu menu_file, menu_view, menu_help;
	Gtk::HPaned hpane;
	Gtk::ScrolledWindow hostgroups_scrolled;
	InstanceList hostgroups_list;
	Gtk::ScrolledWindow services_scrolled;
	NagiosHostList services_view;

public:
	NagiosWindow(OpenWBEM::CIMObjectPath cop);

protected: // callbacks
	void on_menu_file_connect();
	void on_menu_file_quit();
	void on_menu_schema_find_class();
	void on_menu_help_about();
	void on_hostgroup_activated(OpenWBEM::CIMObjectPath hostgroup_cop);
};

#endif /* NAGIOSWINDOW_H */
