#ifndef STATUSMAPCANVAS_H
#define STATUSMAPCANVAS_H

#include "CIMInstanceProxy.h"
#include <libgnomecanvasmm/canvas.h>

class StatusMapCanvas : public Gnome::Canvas::Canvas
{
private:
	CIMInstanceHandle handle;

	class NodeInfo
	{
	public:
		CIMInstanceHandle hContainment;
		Gnome::Canvas::Group *grp;
	};
	std::vector<NodeInfo> nodes;

	// for drag and drop
	CIMInstanceHandle drag_host;
	int drag_x, drag_y;

public:
	StatusMapCanvas(const CIMInstanceHandle &handle);
	void add_host(CIMInstanceHandle host_handle, double xpos, double ypos);

protected: 
	void draw_map();
	void drawContainment(CIMInstanceHandle hContainment);

	// callbacks
	bool on_host_event(GdkEvent *event, CIMInstanceHandle host_handle);
	void on_drag_data_get(const Glib::RefPtr<Gdk::DragContext> &context,
		GtkSelectionData *selection_data_cptr,
		guint info, guint time);
	void on_drag_data_received(const Glib::RefPtr<Gdk::DragContext> &context,
		int x, int y, GtkSelectionData *selection_data,
		guint info, guint time);
	void on_drag_end(const Glib::RefPtr<Gdk::DragContext> &context);
	void on_drag_data_delete(const Glib::RefPtr<Gdk::DragContext> &context);
};

#endif /* STATUSMAPCANVAS_H */
