#ifndef SAMBAGLOBALSETTINGSGENERALFORM_H
#define SAMBAGLOBALSETTINGSGENERALFORM_H

#include <gtkmm/table.h>
#include <gtkmm/entry.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/box.h>

#include <openwbem/OW_CIMObjectPath.hpp>
#include <openwbem/OW_CIMInstance.hpp>
#include <openwbem/OW_CIMProperty.hpp>
#include "Form.h"

class SambaGlobalSettingsGeneralForm : public Form
{
private:
	// keep handle to the instance this form is representing
	OpenWBEM::Reference<OpenWBEM::CIMInstance> inst;

	// notebook tab "General"
	Gtk::Table table;
	Gtk::Label server_name_label,
			server_description_label, workgroup_label, master_browser_label;
	Gtk::Entry server_name_entry,
			server_description_entry, workgroup_entry;
	Gtk::RadioButton_Helpers::Group master_browser_group;
	Gtk::RadioButton master_browser_yes, master_browser_no;
	Gtk::HBox master_browser_box;

	// fills in widgets with current values of instance
	void update();


public:
	// CONSTRUCTOR
	SambaGlobalSettingsGeneralForm();

	// sets instance properties with current text of widgets
	virtual void applyChanges();

	// METHODS DEFINED IN Form
	virtual void set_instance(const OpenWBEM::CIMObjectPath &cop,
			OpenWBEM::Reference<OpenWBEM::CIMInstance> inst);
	virtual Gtk::Widget *getWidget();
};

#endif /* SAMBAGLOBALSETTINGSGENERALFORM_H */
