// Copyright 2004 Jason Long

// This file is part of cimbrowser.
//
// Cimbrowser is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Cimbrowser is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Cimbrowser; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include "SelectClassDialog.h"
#include <gtkmm/stock.h>
#include "main.h"
#include <openwbem/OW_CIMProtocolIFC.hpp>
#include <openwbem/OW_HTTPClient.hpp>
#include <openwbem/OW_CIMXMLCIMOMHandle.hpp>

using namespace Gtk;
using namespace OpenWBEM;

SelectClassDialog::SelectClassDialog()
	: base_class_name(""),
	query_label("Enter Class Name:")
{
	set_title("Select Class");

	query_label.set_alignment(0.0, 0.5);
	
	// initial values
	query_entry.set_activates_default(true);

	// add labels and entries to dialog
	get_vbox()->pack_start(query_label);
	get_vbox()->pack_start(query_entry);

	// add buttons
	add_button(Stock::CANCEL, RESPONSE_CANCEL);
	add_button(Stock::OK, RESPONSE_OK);
	set_default_response(RESPONSE_OK);

	// make sure all children widgets are visible
	show_all_children();
}

String
SelectClassDialog::get_class_name()
{
	return String(query_entry.get_text().c_str());
}

void
SelectClassDialog::set_base_class_name(const String &base_class_name)
{
	query_entry.set_text(base_class_name.c_str());
}
